﻿///////////////////////////////////////////////////////
//
// Decorador MenuBar
//
// O modelo Decorator adaptado para o Flash usa
// uma instância de componente existente no Stage (palco).
//
// Não é permitido usar este código com objetivos militares
// Pode ser utilizado para qualquer outro objetivo
// por sua conta e risco sem implicações de garantia
// (texto e comentários traduzidos por Francisco Teodorico)
//
// Copyright © 2003, Aral Balkan. All Rights Reserved.
// http://www.BitsAndPixels.co.uk
//
///////////////////////////////////////////////////////

import mx.controls.Menu;
import mx.controls.MenuBar;
import menuStructureXML;

class MenuBarDecorator 
{

var menuBarRef:MenuBar;

function MenuBarDecorator ( menuBarRef:MenuBar )
{
this.menuBarRef = menuBarRef;
}

function loadMenuStructure ( xmlFileURL:String, timeline ) 
{
var menuStructure:MenuStructureXML = new MenuStructureXML();

menuStructure.ignoreWhite = true;

// salva os argumentos
menuStructure.menuBarRef = this.menuBarRef;
menuStructure.xmlFileURL = xmlFileURL;
// linha do tempo (timeline) pode ser um objeto ou uma referência a um MC
// que contém os ouvintes (listeners)
menuStructure.timeline = timeline; 

// manipulador onload
menuStructure.onLoad = function (success) 
{

// Quando os dados chegam são passados para o menu
if (success) 
{
// this.menu.dataProvider = this.firstChild;
// faz um loop através das tags de menu e cria um menu
// para cada um deles
// var this:XML = this;
var menus:Array = this.firstChild.childNodes;
var numMenus:Number = menus.length;

if ( numMenus > 0 )
{
// contém referências para as instâncias de menu
var menuInstances:Object = new Object();

for ( var i:Number = 0; i < numMenus; i++ )
{
var currentMenu:XML = menus[i];

var currentMenuName = currentMenu.attributes.name;
var currentMenuInstanceName = currentMenu.attributes.instanceName;
var currentMenuListener = currentMenu.attributes.listener;

// clona o menu atual e então adiciona-o ao menuBar
// não afeta o objeto XML principal (e continua o loop)
var currentMenuClone = currentMenu.cloneNode(true);

// cria o novo menu como um child da instância da barra de menu
var newMenu = this.menuBarRef.addMenu ( currentMenuName, currentMenuClone );

// cria a referencia para o objeto listener (ouvinte)
var eventListener:Object = this.timeline [ currentMenuListener ];

// inclui o listener (ouvinte) para o menu
newMenu.addEventListener ( "change", eventListener );

// salva a referencia na matriz para retornar depois
menuInstances [ currentMenuInstanceName ] = newMenu;
}

// retorna uma matriz de referências para os
// varios menus criados
return menuInstances;
}
else
{
trace ("Nenhum menu encontrado no menu XML.");
}
}
else
{
trace ("Ocorreu um erro no carregamento do menu XML.");
}
};

menuStructure.load( xmlFileURL );
}
}

